/*
	this programe will plot the big dipper based on the assignemtn postions
	with the orignal orogine being the centre of the screen.
	a s d w keys move the dippers orign and both thedipper and the backgroud
	rotates. however when a key is pressed it stops rotateing.
	pressing the left mouse button will restart rotation and while it is
	held plot lines over the big dipper constalation.

  */

#include <windows.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <GL/Gl.h>
#include <GL/glut.h>

#define WINDOW_SIZE_X 1024.0
#define WINDOW_SIZE_Y 800.0
#define PIXEL_SIZE 4.0
#define NUM_STAR 20

const HalfXwin = WINDOW_SIZE_X/2;
const HalfYwin = WINDOW_SIZE_Y/2;
const Xoffset = -100;
const Yoffset =  50;
const MAX = 200; //used for moveing set so wont go outside plan

GLint starset =0,plot=0;
GLint stars[NUM_STAR][8];
GLfloat rotate =0.1,rotate2= 0.0,TransX=0,TransY=0;
GLint stop = 0; 

//<<<<<<<<<<<<<<<<<<<<<<myInit>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void myInit(void)
{
	glClearColor(0.0,0.0,0.0,0.0);	//set black background
	glColor3f(1.0,1.0,1.0);	//set the drawing colour
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(-HalfXwin, HalfXwin, -HalfYwin, HalfYwin);
//	gluOrtho2D(0,WINDOW_SIZE_X,0,WINDOW_SIZE_Y);
    glViewport(0,0,WINDOW_SIZE_X,WINDOW_SIZE_Y);



}

//<<<<<<<<<<<<<<<<<<<<myDisplay>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void myDisplay(void)
{

	GLfloat colour1 =0,colour2 =0,colour3 =0,colour4 =0;
	GLint seed,i;
	
	//create matric of random stars for background
	if(starset == 0)
	{
		seed = time(NULL);	
		srand(seed);
		for(i=0;i<NUM_STAR;i++)
		{
			stars[i][0] = rand()%HalfXwin; //star 1 x
			stars[i][1] = rand()%HalfXwin; //star 1 y
			stars[i][2] = rand()%HalfXwin; //star 2 x
			stars[i][3] = rand()%HalfXwin;
			stars[i][4] = rand()%HalfXwin;
			stars[i][5] = rand()%HalfXwin;
			stars[i][6] = rand()%HalfXwin;
			stars[i][7] = rand()%HalfXwin;
		}
		starset =1;
	}

	glClear(GL_COLOR_BUFFER_BIT);	//clear the screen

	
	glPushMatrix();	//push backfgroud matrix

	
	glRotatef(rotate+=0.1, 0, 0, 1.0);		//rotate the bacground
	
	glBegin(GL_QUADS);								// Start Drawing A square
		glColor3f(0.0,0.0,0.0+colour1);						// Set first point colour
		glVertex2f( -WINDOW_SIZE_X,-WINDOW_SIZE_X);			// First point fof square
		glColor3f(0.0,0.0,0.2+colour1);						// Set Left Point Of Triangle To Green
		glVertex2f(-WINDOW_SIZE_X,WINDOW_SIZE_X);				
		glColor3f(0.0,0.0,0.2+colour3);						
		glVertex2f(WINDOW_SIZE_X,WINDOW_SIZE_X);
		glColor3f(0.0,colour1,1.0-colour3);	
		glVertex2f( WINDOW_SIZE_X,-WINDOW_SIZE_X);	
		
	glEnd();
	//colours of the square will chage from black to blue	



	glBegin(GL_POINTS);	
		glColor3f(.7,.7,.7);	//set the dime star colour
		for(i=0;i<NUM_STAR;i++)
		{
			glVertex2i(-stars[i][1],-stars[i][0]);
			glVertex2i(-stars[i][3],stars[i][2]);
			glVertex2i(stars[i][5],-stars[i][4]);
			glVertex2i(stars[i][7],stars[i][6]);
		}
	//add the random stars
	glEnd();
	glPopMatrix(); //pop background

	glPushMatrix(); //the big dipper
	if(stop==0)  //control of rotation
		rotate2+=.1;
	else
		rotate2=rotate2;

	glTranslatef (TransX, TransY, 0.0);
	glRotatef(rotate2 = (stop==0)?rotate2+.1:rotate2, 0, 0, 1.0);
	
	//low intenisty bakdrop to star
	glPointSize(8);			//a 'dot' is 8 by 8 pixels
	glColor3f(.4,.4,.4+colour4);	//set the drawing colour
	glBegin(GL_POINTS);				//draw 8 points		
		glVertex2i(289+Xoffset,190+Yoffset);
		glVertex2i(320+Xoffset,128+Yoffset);
		glVertex2i(239+Xoffset,67+Yoffset);
		glVertex2i(194+Xoffset,101+Yoffset);
		glVertex2i(129+Xoffset,83+Yoffset);
		glVertex2i(75+Xoffset,73+Yoffset);
		glVertex2i(74+Xoffset,74+Yoffset);
		glVertex2i(20+Xoffset,10+Yoffset);

	glEnd();
	
	//star points
	glPointSize(2);			//a 'dot' 2pixel
	glColor3f(1.0,1.0,1.0);	//set the drawing colour
	glBegin(GL_POINTS);				//draw 8 points		
		glVertex2i(289+Xoffset,190+Yoffset);
		glVertex2i(320+Xoffset,128+Yoffset);
		glVertex2i(239+Xoffset,67+Yoffset);
		glVertex2i(194+Xoffset,101+Yoffset);
		glVertex2i(129+Xoffset,83+Yoffset);
		glVertex2i(75+Xoffset,73+Yoffset);
		glVertex2i(74+Xoffset,74+Yoffset);
		glVertex2i(20+Xoffset,10+Yoffset);
	glEnd();


	//draw lines over big dipper if in correct mode
	if(plot==1)
	{
		glPointSize(2);			//a 'dot' is 8 by 8 pixels
		glColor3f(1,0,0);	//set the drawing colour
		glBegin(GL_LINE_STRIP);
			glVertex2i(194+Xoffset,101+Yoffset);
			glVertex2i(289+Xoffset,190+Yoffset);
			glVertex2i(320+Xoffset,128+Yoffset);
			glVertex2i(239+Xoffset,67+Yoffset);
			glVertex2i(194+Xoffset,101+Yoffset);
			glVertex2i(129+Xoffset,83+Yoffset);
			glVertex2i(75+Xoffset,73+Yoffset);
			glVertex2i(74+Xoffset,74+Yoffset);
			glVertex2i(20+Xoffset,10+Yoffset);
			
		glEnd();
	}
	


	glPopMatrix();
	
	//change intensityes
	colour1 =colour1<=1?0 :colour1+0.1;
	colour2 =colour2<=1?0 :colour2+0.1;
	colour3 =colour3<=1?0 :colour3+0.1;
	colour4 =colour4<=1?0 :colour4+0.2;

	glutPostRedisplay();//updated
	glutSwapBuffers();
//	glFlush();						//send all to display
}

//<<<<<<<<<<<<<<<<<<<<<<mouse>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void myMouse(int button, int state, int x, int y)
{
        if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
        {
			plot = 1;	//place lines over points
			stop =1;	//stop rotation
		}
		else
		{
			plot = 0;	//take off ploting
			stop =0;	//start rotation
		}

		
}
//<<<<<<<<<<<<<<<<<<<<<<keyboad>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void myKeyboard(unsigned char key,int x, int y)
{
      	//use keys to translte big dipper
        switch(key)
        {	
            case 'a':

					TransX +=-1;
					stop = 1; //STOP rotate
				break;
			case 'd':
					TransX +=1;
					stop = 1; //STOP rotate
				break;
            case 'w':
					TransY +=1;
					stop = 1; //STOP rotate
                break;
			case 's':
					TransY +=-1;
					stop = 1; //STOP rotate
                break;
			case 27:    //ESC key
                exit(1); //exit program
            default:
                break;
        }
	
}




//<<<<<<<<<<<<<<<<<<<<<main>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void main(int argc, char** argv)
{
	glutInit(&argc,argv);	//initialise the tool kit
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);	//set display mode
	//glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);	//set display mode

	glutInitWindowSize(WINDOW_SIZE_X,WINDOW_SIZE_Y);	//set window size
	glutInitWindowPosition(0,0);	//set window postion
	glutCreateWindow("Chris' Big Dipper");	//open window
	glutDisplayFunc(myDisplay);		//register redraw function
	glutMouseFunc(myMouse);			//look for mouse events
	glutKeyboardFunc(myKeyboard);	//look for keyboad events
	myInit();
	

	glutMainLoop(); // shows the window and loops to accepts and processes input events
	
	
}
